/* QmailAdmin 
 * Copyright (C) 1999 Inter7 Internet Technologies, Inc. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pwd.h>
#include <dirent.h>
#include "config.h"
#include "qmailadmin.h"
#include "qmailadminx.h"
#include <errno.h>

char dotqmail_name[MAX_FILE_NAME];
int dotnum;

int show_mailing_lists(char *user, char *dom, time_t mytime)
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	/* see if there's anything to display */
	count_mailinglists();
 	if ( CurMailingLists == 0 ) {
		sprintf(StatusMessage,"%s", get_html_text("231"));
		show_menu();
		vclose();
		exit(0);
	}

 	if ( MaxMailingLists == 0 ) {
		return(0);
	}
	send_template( "show_mailinglist.html" );
}

int show_mailing_list_line(char *user, char* dom, time_t mytime, char *dir)
{
	DIR *mydir;
	struct dirent *mydirent;
	FILE *fs;
	char mailinglist_name[MAX_FILE_NAME];
	int i,j;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

 	if ( MaxMailingLists == 0 ) {
		return(0);
	}

	if ( (mydir = opendir(".")) == NULL ) {
		fprintf(actout,"<tr><td>%s %d</tr><td>", get_html_text("143"), 1);
		return(0);
	}


	/* First display the title row */
	fprintf(actout, "<tr bgcolor=\"#cccccc\">");
#ifdef EZMLMIDX
	fprintf(actout, "<th align=\"left\"><font size=\"2\">%s<br>%s</font></th>", get_html_text("081"), get_html_text("224"));
#else
	fprintf(actout, "<th align=\"left\"><font size=\"2\">%s</font></th>", get_html_text("081"));
#endif
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("072"));
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("083"));
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("084"));
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("085"));
#ifdef EZMLMIDX
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("086"));
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("087"));
	fprintf(actout, "<th align=\"center\"><font size=\"2\">%s</font></th>", get_html_text("088"));
#endif
	fprintf(actout, "</tr>\n");
 

	/* Now, display each list */
	while( (mydirent=readdir(mydir)) != NULL ) {
		if ( strncmp(".qmail-", mydirent->d_name, 7) == 0 ) {
			if ( (fs=fopen(mydirent->d_name,"r"))==NULL) {
#ifdef EZMLMIDX
				fprintf(actout, "<tr><td colspan=\"8\">%s %s</td></tr>\n", get_html_text("144"), mydirent->d_name);
#else
				fprintf(actout, "<tr><td colspan=\"5\">%s %s</td></tr>\n", get_html_text("144"), mydirent->d_name);
#endif
				continue;
			}
			fgets( TmpBuf2, MAX_BUFF, fs);
			if ( strstr( TmpBuf2, "ezmlm-reject") != 0 ) {
				for(i=7,j=0;j<MAX_FILE_NAME-1&&mydirent->d_name[i]!=0;++i,++j) {
					mailinglist_name[j] = mydirent->d_name[i];
				}
				mailinglist_name[j] = 0;

                /* make dotqmail name */
                strcpy(dotqmail_name, mailinglist_name);
                for(dotnum=0;dotqmail_name[dotnum]!='\0';dotnum++) {
                    if(dotqmail_name[dotnum]==':') dotqmail_name[dotnum] = '.';
                }

				fprintf(actout,"<tr>");
#ifdef EZMLMIDX
				fprintf(actout, "<td align=\"left\"><a href=\"%s/com/modmailinglist?user=%s&dom=%s&time=%d&modu=%s\">%s@%s</a></td>\n", 
					CGIPATH,user,Domain,mytime,dotqmail_name,dotqmail_name,Domain); 
#else
				fprintf(actout,"<td align=\"left\">%s@%s</td>\n", 
					dotqmail_name, Domain); 
#endif
				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/delmailinglist?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");

				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/addlistuser?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");

				fprintf(actout, "<td align=\"center\"><a href=\"%s/com/dellistuser?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");

				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/showlistusers?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");
#ifdef EZMLMIDX
				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/addlistmod?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");

				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/dellistmod?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");

				fprintf(actout, "<td align=\"center\">");
				fprintf(actout, "<a href=\"%s/com/showlistmod?user=%s&dom=%s&time=%d&modu=%s\">",
					CGIPATH,user,dom,mytime,dotqmail_name);
				fprintf(actout, "<img src=\"/images/qmailadmin/delete.png\" border=\"0\"></a>");
				fprintf(actout, "</td>\n");
#endif
				fprintf(actout, "</tr>\n");
			}
			fclose(fs);
		}
	}
	closedir(mydir);
}

int is_mailing_list(FILE *fs)
{
       while (!feof(fs)) {
               fgets( TmpBuf2, MAX_BUFF, fs);
               if ( strstr( TmpBuf2, "ezmlm-reject") != 0 ||
                    strstr( TmpBuf2, "ezmlm-send")   != 0 )
                       return -1;
       }
       return 0;
}

int show_mailing_list_line2(char *user, char *dom, time_t mytime, char *dir)
{
 DIR *mydir;
 struct dirent *mydirent;
 FILE *fs;
 char mailinglist_name[MAX_FILE_NAME];
 int i,j, cnt = 0;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

 	if ( MaxMailingLists == 0 ) {
		return(0);
	}

    if ( (mydir = opendir(".")) != NULL){
		while( (mydirent = readdir(mydir)) != NULL)
			if( strncmp(".qmail-", mydirent->d_name, 7) == 0){
				if( (fs = fopen(mydirent->d_name, "r")) == NULL){
					fprintf(actout,"%s %s<br>\n", get_html_text("144"),
						mydirent->d_name);
					continue;
				}
				if (is_mailing_list(fs)) num_of_mailinglist++;
				fclose(fs);
			}
		closedir(mydir);
	}
	fprintf(actout, "<INPUT NAME=number_of_mailinglist TYPE=hidden VALUE=%d>\n", num_of_mailinglist);

	if ( (mydir = opendir(".")) == NULL ) {
		fprintf(actout,"%s %d<BR>\n", get_html_text("143"), 1);
		fprintf(actout,"</table>");
		return(0);
	}

    cnt = 0;
	while( (mydirent=readdir(mydir)) != NULL ) {
		if ( strncmp(".qmail-", mydirent->d_name, 7) == 0 ) {
			if ( (fs=fopen(mydirent->d_name,"r"))==NULL) {
				fprintf(actout,"%s %s<br>\n", get_html_text("144"),
					mydirent->d_name);
				continue;
			}
			fgets( TmpBuf2, MAX_BUFF, fs);
			if ( strstr( TmpBuf2, "ezmlm-reject") != 0 ) {

				for(i=7,j=0;j<MAX_FILE_NAME-1&&mydirent->d_name[i]!=0;++i,++j) {
					mailinglist_name[j] = mydirent->d_name[i];
				}
				mailinglist_name[j] = 0;

	            fprintf(actout,"<TR><TD align=center>%s@%s</TD><TD \
align=center><INPUT NAME=\"subscribe%d\" TYPE=\"checkbox\" \
VALUE=%s></TD></TR>", mailinglist_name, Domain, cnt++, mailinglist_name); 
              
			}
			fclose(fs);
		}
	}
	closedir(mydir);

}


int addmailinglist(void)
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	count_mailinglists();
	load_limits();
	if ( MaxMailingLists != -1 && CurMailingLists >= MaxMailingLists ) {
		fprintf(actout, "%s %d\n", get_html_text("184"), 
			MaxMailingLists);
		show_menu();
		vclose();
		exit(0);
	}
#ifdef EZMLMIDX
	send_template( "add_mailinglist-idx.html" );
#else
	send_template( "add_mailinglist-no-idx.html" );
#endif

}

int delmailinglist(void)
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	send_template( "del_mailinglist_confirm.html" );
}

int delmailinglistnow(void)
{
 int pid;
 DIR *mydir;
 struct dirent *mydirent;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	if ( (mydir = opendir(".")) == NULL ) {
		fprintf(actout,"%s %d<BR>\n", get_html_text("143"), 1);
		fprintf(actout,"</table>");
		return 0;
	}
 
    /* make dotqmail name */
    strcpy(dotqmail_name, ActionUser);
    for(dotnum=0;dotqmail_name[dotnum]!='\0';dotnum++) {
        if(dotqmail_name[dotnum]=='.') dotqmail_name[dotnum] = ':';
    }

	sprintf(TmpBuf2, ".qmail-%s", dotqmail_name);
	sprintf(TmpBuf3, ".qmail-%s-", dotqmail_name);
	while( (mydirent=readdir(mydir)) != NULL ) {

		/* delete the main .qmail-"list" file */
		if ( strcmp(TmpBuf2, mydirent->d_name) == 0 ) {
			if ( unlink(mydirent->d_name) != 0 ) {
				ack(get_html_text("185"), TmpBuf2);
			}

		/* delete secondary .qmail-list"-* files */
		} else if ( strncmp(TmpBuf3, mydirent->d_name, strlen(TmpBuf3)) == 0 ) {
			if ( unlink(mydirent->d_name) != 0 ) {
				ack(get_html_text("185"), TmpBuf2);
			}
		}
	}
	closedir(mydir);


	sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);
	vdelfiles(TmpBuf2);

    count_mailinglists();
	sprintf(StatusMessage, "%s %s\n", get_html_text("186"), ActionUser);
    if ( CurMailingLists == 0 ) {
        show_menu();
    } else {
		show_mailing_lists(Username, Domain, Mytime);
	}

}


int addmailinglistnow(void)
{
	FILE * file;
	int pid;

#ifdef EZMLMIDX
	char list_owner[MAX_BUFF];
	char owneremail[MAX_BUFF+5];	
#endif
	char options[MAX_BUFF];
	char *arguments[MAX_BUFF];
	int i=0;
	char tmp[MAX_BUFF];
	char *tmpstr;
	char loop_ch[MAX_BUFF];
	int  loop;
	int  num_choices;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

        count_mailinglists();
        load_limits();
        if ( MaxMailingLists != -1 && CurMailingLists >= MaxMailingLists ) {
                fprintf(actout, "%s %d\n", get_html_text("184"),
                        MaxMailingLists);
                show_menu();
                vclose();
                exit(0);
        }

	if ( fixup_local_name(ActionUser) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("188"), ActionUser);
		addmailinglist();
		vclose();
		exit(0);
	}
	if ( check_local_user(ActionUser) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("175"), ActionUser);
		addmailinglist();
		vclose();
		exit(0);
	}


	memset(options, 0, MAX_BUFF);
	memset(loop_ch, 0, MAX_BUFF);

#ifdef EZMLMIDX
	/* check the list owner entry */
	GetValue(TmpCGI, list_owner, "listowner=", MAX_BUFF); // Get the listowner
	memset(owneremail, 0, MAX_BUFF);
	if ( strlen(list_owner) > 0 ) {
		strcpy( owneremail, "-5");
		strcat( owneremail, list_owner);
	}
#endif

#ifdef EZMLMIDX
	num_choices = NUM_EZMLM_IDX_CHOICES;
#else
	num_choices = NUM_EZMLM_NO_IDX_CHOICES;
#endif

	memset(options, 0, MAX_BUFF);
	for(loop = 0; loop < num_choices; loop++) {	
		sprintf(tmp, "param%d=", loop);
		memset(loop_ch, 0, MAX_BUFF);
		GetValue(TmpCGI, loop_ch, tmp, MAX_BUFF);

		if ( strlen(loop_ch) > 0 ) {
			strcat(options, loop_ch);
			strcat(options, " ");
		}
	}

#ifdef EZMLMIDX
	/* check for sql support */
	memset(tmp, 0, MAX_BUFF);
	GetValue(TmpCGI, tmp, "sqlsupport=", MAX_BUFF);
	if( strlen(tmp) > 0 ) {
		strcat(options, tmp);
		strcat(options, " ");
		for(loop = 0; loop < NUM_SQL_OPTIONS; loop++) {	
			sprintf(tmp, "sql%d=", loop+1);
			memset(loop_ch, 0, MAX_BUFF);
			GetValue(TmpCGI, loop_ch, tmp, MAX_BUFF);
			strcat(options, loop_ch);
	    		if(loop < NUM_SQL_OPTIONS - 1) strcat(options, ":");
		}
	}
#endif

	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-make", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);

        /* make dotqmail name */
        strcpy(dotqmail_name, ActionUser);
        for(dotnum=0;dotqmail_name[dotnum]!='\0';dotnum++) {
            if(dotqmail_name[dotnum]=='.') dotqmail_name[dotnum] = ':';
        }
		sprintf(TmpBuf3, "%s/.qmail-%s", RealDir, dotqmail_name);
		i = 0;
		arguments[i++] = "ezmlm-make";

#ifdef EZMLMIDX
		if ( strlen(owneremail) > 0 ) arguments[i++]=owneremail;
#endif

		for(tmpstr=strtok(options," ");tmpstr!=NULL;tmpstr=strtok(NULL," ")){
			arguments[i++] = tmpstr;
		}
		arguments[i++]=TmpBuf2;
		arguments[i++]=TmpBuf3;
		arguments[i++]=ActionUser;
		arguments[i++]=Domain;
		arguments[i++]=NULL;

		execv(TmpBuf1, arguments);
		exit(127);
	} else {
		wait(&pid);
	}

	sprintf(TmpBuf, "%s/%s/inlocal",
		RealDir, ActionUser);

  	file=fopen(TmpBuf , "w");
	fprintf(file, "%s-%s", Domain, ActionUser);
	fclose(file);

	sprintf(StatusMessage, "%s %s@%s\n", get_html_text("187"), 
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);

}

int show_list_users(void)
{
	if (AdminType != DOMAIN_ADMIN) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	if (MaxMailingLists == 0) {
		return 0;
	}
	
	send_template("show_subscribers.html");
}



int show_list_users_now(void)
{
 FILE *fs;
 int i,handles[2],pid,a,x,y,z = 0,z1=1,index = 0,subuser_count = 0; 
 unsigned char *pa[65536];
 unsigned char sublist[65536][96];
 char *p,*wack;


	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(ActionUser);
	pipe(handles);

	pid=fork();
	if (pid==0) {
		close(handles[0]);
		dup2(handles[1],fileno(stdout));
		sprintf(TmpBuf1, "%s/ezmlm-list", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-list", TmpBuf2, NULL);
		exit(127);
	} else {
                close(handles[1]);
		fs = fdopen(handles[0],"r");

                /* Load subscriber list into array */

                while( fgets(sublist[index], sizeof(sublist[index]), fs)!= NULL) {
                        i = strlen(sublist[index]); --i; sublist[index][i] = 0;
                        pa[index] = sublist[index];
                        index++; subuser_count++;
                }

                /* Sort the array alphabetically - future version will sort by domain also */

                  for(a = 0; a < index-1 ; ++a) {
                        for(x = a+1; x < index; ++x) {
                                z = strcmp(pa[a],pa[x]);
                                if(z > 0) {
                                        wack = pa[a];
                                        pa[a] = pa[x];
                                        pa[x] = wack; 
                                }
                        }
                }

		/* Display subsriber list, along with delete button */
		fprintf(actout,"<TABLE border=0 width=\"100%%\">\n");
		fprintf(actout,"    <TR>\n");
		fprintf(actout,"    <TH align=left><B>%s</B> %d<BR><BR></TH>\n", get_html_text("230"), subuser_count);
		fprintf(actout,"    </TR>\n");
		fprintf(actout,"    <TR align=middle bgcolor=%s>\n", get_color_text("002"));
		fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("222"));
		fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("084"));
        fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("222"));
        fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("084"));
		fprintf(actout,"    </TR>\n");

		for(z = 0; z < index; ++z) {
			fprintf(actout,"    <TR align=middle>");
			fprintf(actout,"        <TD align=\"left\">%s</TD>\n", pa[z]);
			fprintf(actout,"        <TD align=\"left\"><A href=%s/com/dellistusernow?modu=%s&newu=%s&dom=%s&user=%s&time=%d><IMG src=/images/qmailadmin/delete.png border=0></A></TD>\n",
				CGIPATH, ActionUser, pa[z], Domain, Username, Mytime);
			++z;
			if(pa[z] != NULL) {
            	fprintf(actout,"        <TD align=\"left\">%s</TD>", pa[z]);
            	fprintf(actout,"        <TD align=\"left\"><A href=%s/com/dellistusernow?modu=%s&newu=%s&dom=%s&user=%s&time=%d><IMG src=/images/qmailadmin/delete.png border=0></A></TD>\n",CGIPATH, ActionUser, pa[z], Domain, Username, Mytime);
			} else {
            	fprintf(actout,"        <TD align=\"left\">-</TD>");
            	fprintf(actout,"        <TD align=\"left\">-</TD>\n");
			}
			fprintf(actout,"    </TR>");
		}

		fprintf(actout,"</TABLE>");
		fclose(fs); close(handles[0]);
        	wait(&pid);
		sprintf(StatusMessage, "%s\n", get_html_text("190"));
		fprintf(actout, get_html_text("END_LIST_NAMES"));
	}
}

show_list_moderators()
{
        if ( AdminType!=DOMAIN_ADMIN ) {
                sprintf(StatusMessage,"%s", get_html_text("142"));
                vclose();
                exit(0);
        }

        if ( MaxMailingLists == 0 ) {
                return(0);
        }
        send_template( "show_moderators.html" );
}

int show_list_moderators_now(void)
{
 FILE *fs;
 int i,handles[2],pid,a,x,y,z = 0,z1=1,index = 0,subuser_count = 0; 
 unsigned char *pa[65536];
 unsigned char sublist[65536][96];
 char *p,*wack;


	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(ActionUser);
	pipe(handles);

	pid=fork();
	if (pid==0) {
		close(handles[0]);
		dup2(handles[1],fileno(stdout));
		sprintf(TmpBuf1, "%s/ezmlm-list", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s/mod", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-list", TmpBuf2, NULL);
		exit(127);
	} else {
                close(handles[1]);
		fs = fdopen(handles[0],"r");

                /* Load moderator list into array */

                while( fgets(sublist[index], sizeof(sublist[index]), fs)!= NULL) {
                        i = strlen(sublist[index]); --i; sublist[index][i] = 0;
                        pa[index] = sublist[index];
                        index++; subuser_count++;
                }

                /* Sort the array alphabetically - future version will sort by domain also */

                  for(a = 0; a < index-1 ; ++a) {
                        for(x = a+1; x < index; ++x) {
                                z = strcmp(pa[a],pa[x]);
                                if(z > 0) {
                                        wack = pa[a];
                                        pa[a] = pa[x];
                                        pa[x] = wack; 
                                }
                        }
                }

		/* Display moderator list, along with delete button */
		fprintf(actout,"<TABLE border=0 width=\"100%%\">\n");
		fprintf(actout,"    <TR>\n");
		fprintf(actout,"    <TH align=left><B>%s</B> %d<BR><BR></TH>\n", get_html_text("228"), subuser_count);
		fprintf(actout,"    </TR>\n");
		fprintf(actout,"    <TR align=middle bgcolor=%s>\n", get_color_text("002"));
		fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("220"));
		fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("087"));
        fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("220"));
        fprintf(actout,"        <TH align=middle><b><font size=\"2\">%s</font></b></TH>\n", get_html_text("087"));
		fprintf(actout,"    </TR>\n");

		for(z = 0; z < index; ++z) {
			fprintf(actout,"    <TR align=middle>");
			fprintf(actout,"        <TD align=\"left\">%s</TD>\n", pa[z]);
			fprintf(actout,"        <TD align=\"left\"><A href=%s/com/dellistmodnow?modu=%s&newu=%s&dom=%s&user=%s&time=%d><IMG src=/images/qmailadmin/delete.png border=0></A></TD>\n",
				CGIPATH, ActionUser, pa[z], Domain, Username, Mytime);
			++z;
			if(pa[z] != NULL) {
            	fprintf(actout,"        <TD align=\"left\">%s</TD>", pa[z]);
            	fprintf(actout,"        <TD align=\"left\"><A href=%s/com/dellistmodnow?modu=%s&newu=%s&dom=%s&user=%s&time=%d><IMG src=/images/qmailadmin/delete.png border=0></A></TD>\n",CGIPATH, ActionUser, pa[z], Domain, Username, Mytime);
			} else {
            	fprintf(actout,"        <TD align=\"left\">-</TD>");
            	fprintf(actout,"        <TD align=\"left\">-</TD>\n");
			}
			fprintf(actout,"    </TR>");
		}

		fprintf(actout,"</TABLE>");
		fclose(fs); close(handles[0]);
        	wait(&pid);
		sprintf(StatusMessage, "%s\n", get_html_text("190"));
		fprintf(actout, get_html_text("END_LIST_NAMES"));
	}
}

addlistuser()
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}
	send_template( "add_listuser.html" );
}

addlistmod()
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}
	send_template( "add_listmod.html" );
}

addlistusernow()
{
 int i, result;
 int pid;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(ActionUser);

	if ( check_email_addr(Newu) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("148"), Newu);
		addlistuser();
		vclose();
		exit(0);
	}

	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-sub", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-sub", TmpBuf2, Newu, NULL);
		exit(127);
	} else wait(&pid);

	sprintf(StatusMessage, "%s %s %s@%s\n", Newu, get_html_text("193"),
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);
	vclose();
	exit(0);
	

}

addlistmodnow()
{
 int i, result;
 int pid;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(ActionUser);

	if ( check_email_addr(Newu) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("148"), Newu);
		addlistuser();
		vclose();
		exit(0);
	}

	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-sub", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s/mod", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-sub", TmpBuf2, Newu, NULL);
		exit(127);
	} else wait(&pid);

	sprintf(StatusMessage, "%s %s %s@%s\n", Newu, get_html_text("194"), 
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);
	vclose();
	exit(0);

}

dellistuser()
{
	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	send_template( "del_listuser.html" );

}

dellistmod()
{

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	send_template( "del_listmod.html" );

}

dellistusernow()
{
 int i;
 int pid;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(Newu);

	if ( check_email_addr(Newu) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("148"), Newu);
		dellistuser();
		vclose();
		exit(0);
	}
	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-unsub", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-unsub", TmpBuf2, Newu, NULL);
		exit(127);
	} else wait(&pid);

	sprintf(StatusMessage, "%s %s %s@%s\n", Newu, get_html_text("203"),
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);
	vclose();
	exit(0);
}

dellistmodnow()
{
 int i;
 int pid;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	lowerit(Newu);

	if ( check_email_addr(Newu) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("148"), Newu);
		dellistmod();
		vclose();
		exit(0);
	}
	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-unsub", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s/mod", RealDir, ActionUser);
		execl(TmpBuf1, "ezmlm-unsub", TmpBuf2, Newu, NULL);
		exit(127);
	} else wait(&pid);

	sprintf(StatusMessage, "%s %s %s@%s\n", Newu, get_html_text("197"),
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);
		vclose();
	exit(0);
}

count_mailinglists()
{
 DIR *mydir;
 struct dirent *mydirent;
 FILE *fs;

	if ( (mydir = opendir(".")) == NULL ) {
		fprintf(actout,"%s %d<BR>\n", get_html_text("143"), 1);
		fprintf(actout,"</table>");
		return(0);
	}
 

	CurMailingLists = 0;
	while( (mydirent=readdir(mydir)) != NULL ) {
		if ( strncmp(".qmail-", mydirent->d_name, 7) == 0 ) {
			if ( (fs=fopen(mydirent->d_name,"r"))==NULL) {
				fprintf(actout, get_html_text("FAIL_PERM_ERROR"), 
					mydirent->d_name);
				continue;
			}
			fgets( TmpBuf2, MAX_BUFF, fs);
			if ( strstr( TmpBuf2, "ezmlm-reject") != 0 ) {
				++CurMailingLists;
			}
			fclose(fs);
		}
	}
	closedir(mydir);

}

modmailinglist()
{
 int i;
 FILE *fs;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	/* get the current listowner and copy it to Alias */
	sprintf(TmpBuf, ".qmail-%s-owner", ActionUser);
	if((fs=fopen(TmpBuf, "r"))!=NULL) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if(strstr(TmpBuf2, "@")!=NULL) {
				sprintf(Alias, "%s", TmpBuf2);
			}
		}
		fclose(fs);
		i = strlen(Alias); --i; Alias[i] = 0; /* take off newline */
	}

#ifdef EZMLMIDX
	send_template( "mod_mailinglist-idx.html" );
#else
	send_template( "show_mailinglists.html" );
#endif

}

modmailinglistnow()
{
	FILE * file;
	int pid;

#ifdef EZMLMIDX
	char list_owner[MAX_BUFF];
	char owneremail[MAX_BUFF+5];	
#endif
	char options[MAX_BUFF];
	char *arguments[MAX_BUFF];
	int i=0;
	char tmp[MAX_BUFF];
	char *tmpstr;
	char loop_ch[MAX_BUFF];
	int  loop;
	int  num_choices;

	if ( AdminType!=DOMAIN_ADMIN ) {
		sprintf(StatusMessage,"%s", get_html_text("142"));
		vclose();
		exit(0);
	}

	if ( fixup_local_name(ActionUser) ) {
		sprintf(StatusMessage, "%s %s\n", get_html_text("188"), ActionUser);
		addmailinglist();
		vclose();
		exit(0);
	}

	memset(options, 0, MAX_BUFF);
	memset(loop_ch, 0, MAX_BUFF);

#ifdef EZMLMIDX
	/* check the list owner entry */
	GetValue(TmpCGI, list_owner, "listowner=", MAX_BUFF); // Get the listowner
	memset(owneremail, 0, MAX_BUFF);
	if ( strlen(list_owner) > 0 ) {
		strcpy( owneremail, "-5");
		strcat( owneremail, list_owner);
	}
#endif

#ifdef EZMLMIDX
	num_choices = NUM_EZMLM_IDX_CHOICES;
#else
	num_choices = NUM_EZMLM_NO_IDX_CHOICES;
#endif

	memset(options, 0, MAX_BUFF);
	for(loop = 0; loop < num_choices; loop++) {	
		sprintf(tmp, "param%d=", loop);
		memset(loop_ch, 0, MAX_BUFF);
		GetValue(TmpCGI, loop_ch, tmp, MAX_BUFF);

		if ( strlen(loop_ch) > 0 ) {
			strcat(options, loop_ch);
			strcat(options, " ");
		}
	}

#ifdef EZMLMIDX
	/* check for sql support */
	memset(tmp, 0, MAX_BUFF);
	GetValue(TmpCGI, tmp, "sqlsupport=", MAX_BUFF);
	if( strlen(tmp) > 0 ) {
		strcat(options, tmp);
		strcat(options, " ");
		for(loop = 0; loop < NUM_SQL_OPTIONS; loop++) {	
			sprintf(tmp, "sql%d=", loop+1);
			memset(loop_ch, 0, MAX_BUFF);
			GetValue(TmpCGI, loop_ch, tmp, MAX_BUFF);
			strcat(options, loop_ch);
	    		if(loop < NUM_SQL_OPTIONS - 1) strcat(options, ":");
		}
	}
#endif

	pid=fork();
	if (pid==0) {
		sprintf(TmpBuf1, "%s/ezmlm-make", EZMLMDIR);
		sprintf(TmpBuf2, "%s/%s", RealDir, ActionUser);
        /* make dotqmail name */
        strcpy(dotqmail_name, ActionUser);
        for(dotnum=0;dotqmail_name[dotnum]!='\0';dotnum++) {
            if(dotqmail_name[dotnum]=='.') dotqmail_name[dotnum] = ':';
        }
		sprintf(TmpBuf3, "%s/.qmail-%s", RealDir, dotqmail_name);
		i = 0;
		arguments[i++] = "ezmlm-make";

#ifdef EZMLMIDX
		if ( strlen(owneremail) > 0 ) arguments[i++]=owneremail;
#endif

		for(tmpstr=strtok(options," ");tmpstr!=NULL;tmpstr=strtok(NULL," ")){
			arguments[i++] = tmpstr;
		}
		arguments[i++]=TmpBuf2;
		arguments[i++]=TmpBuf3;
		arguments[i++]=ActionUser;
		arguments[i++]=Domain;
		arguments[i++]=NULL;

		execv(TmpBuf1, arguments);
		exit(127);
	} else {
		wait(&pid);
		if(strstr(options, "-M") != NULL) {
			strcpy(TmpBuf2, "moderator");
			del_list_links(TmpBuf2);
		}
		if(strstr(options, "-D") != NULL) {
			strcpy(TmpBuf2, "digest");
			del_list_links(TmpBuf2);
		}
	}

	sprintf(TmpBuf, "%s/%s/inlocal",
		RealDir, ActionUser);

  	file=fopen(TmpBuf , "w");
	fprintf(file, "%s-%s", Domain, ActionUser);
	fclose(file);

	sprintf(StatusMessage, "%s %s@%s\n", get_html_text("226"), 
		ActionUser, Domain);
	show_mailing_lists(Username, Domain, Mytime);

}

show_current_list_values() {
 FILE *fs;
 char checked1[MAX_BUFF];
 char checked2[MAX_BUFF];
 char spacestring[MAX_BUFF];
 int sqlfileok = 0;
 int usesql = 0;
 int i,j;

	/* make the html pretty ; ) */
	strcpy(spacestring, "                ");

    /* make dotqmail name */
    strcpy(dotqmail_name, ActionUser);
    for(dotnum=0;dotqmail_name[dotnum]!='\0';dotnum++) {
        if(dotqmail_name[dotnum]=='.') dotqmail_name[dotnum] = ':';
    }

	/* See if it's moderated or not */
	sprintf(TmpBuf, ".qmail-%s-accept-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param0 value=-m %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n", spacestring, get_html_text("035"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param0 value=-M %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n", spacestring, get_html_text("036"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if it's archived or not */
	sprintf(TmpBuf, "%s/archived", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param1 value=-a %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n", spacestring, get_html_text("018"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param1 value=-A %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n", spacestring, get_html_text("019"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if it's blocked or not */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-get", "P")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param2 value=-b %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("020"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param2 value=-B %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("021"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if it's there's a digest or not */
	sprintf(TmpBuf, "%s/digest/bouncer", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param3 value=-d %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n", spacestring, get_html_text("227"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param3 value=-D %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("022"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if a prefix is used */
	sprintf(TmpBuf, "%s/prefix", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param4 value=-f %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("023"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param4 value=-F %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("024"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if hte archive is guarded */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-get", "s")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param5 value=-g %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("025"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param5 value=-G %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("026"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if subscriptions require confirmation */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-manage", "S")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param6 value=-h %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("027"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param6 value=-H %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("028"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if a WWW index is kept */
	sprintf(TmpBuf, ".qmail-%s-accept-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if(strstr(TmpBuf2, "ezmlm-archive") !=0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param7 value=-i %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("029"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param7 value=-I %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("030"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if unsubscriptions require confirmation */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-manage", "U")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param8 value=-j %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("031"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param8 value=-J %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("032"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if list administrators can get the subscriber list */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-manage", "l")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param9 value=-l %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("033"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param9 value=-L %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("034"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* see if remote administrators may edit text files */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-manage", "e")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param10 value=-n %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("041"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param10 value=-N %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("042"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* see if only moderators can post */
	sprintf(TmpBuf, ".qmail-%s", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((get_ezmlmidx_line_arguments(TmpBuf2, "ezmlm-store", "P")) > 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param11 value=-o %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("037"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param11 value=-O %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("038"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if it's public or not */
	sprintf(TmpBuf, "%s/public", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param12 value=-p %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("039"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param12 value=-P %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("040"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* see if ReQuest address is serviced */
	sprintf(TmpBuf, ".qmail-%s-default", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((strstr(TmpBuf2, "ezmlm-request")) != 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param13 value=-q %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("043"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param13 value=-Q %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("044"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if remote administration is allowed */
	sprintf(TmpBuf, "%s/remote", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param14 value=-r %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("045"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param14 value=-R %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("046"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if subscriptions are moderated */
	sprintf(TmpBuf, "%s/modsub", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param15 value=-s %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("047"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param15 value=-S %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("048"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* See if there is a trailer */
	sprintf(TmpBuf, "%s/text/trailer", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param16 value=-t %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("049"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param16 value=-T %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("050"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	/* see if list posts are restricted by sender address */
	sprintf(TmpBuf, ".qmail-%s", dotqmail_name);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			if((strstr(TmpBuf2, "ezmlm-gate")) != 0 || (strstr(TmpBuf2, "ezmlm-issubn")) != 0) {
				strcpy(checked1, "checked");
			}
		}
		if(strstr(checked1, "checked") == 0) {
			strcpy(checked2, "checked");
		}
		fclose(fs);
	} else {
		strcpy(checked2, "checked");
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param17 value=-u %s></td>\n", spacestring, checked1);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("051"));
	fprintf(actout, "%s  <td>\n", spacestring);
	fprintf(actout, "%s    <input type=radio name=param17 value=-U %s></td>\n", spacestring, checked2);
	fprintf(actout, "%s    <input type=hidden name=param18 value=-e></td>\n", spacestring);
	fprintf(actout, "%s  <td>%s</td>\n",  spacestring, get_html_text("052"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = 0; checked2[0] = 0;


	fprintf(actout, "%s</table>\n", spacestring);
	fprintf(actout, "%s    <hr>\n", spacestring);
	fprintf(actout, "%s<table width=\"100%%\" cellpadding=\"1\" cellspacing=\"0\" border=\"0\" bgcolor=%s><tr><td>\n", 
		spacestring, get_color_text("001"));
	fprintf(actout, "%s<table width=\"100%%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n", spacestring);

	/***********************/
	/* begin MySQL options */
	/***********************/

	/* See if sql is turned on */
	sprintf(TmpBuf, "%s/sql", ActionUser);
	if( (fs=fopen(TmpBuf, "r")) !=NULL ) {
		strcpy(checked1, "checked");
		while(fgets(TmpBuf2, MAX_BUFF, fs)) {
			strcpy(TmpBuf1, TmpBuf2);
			i = strlen(TmpBuf1); --i; TmpBuf1[i] = 0; /* take off newline */
			if((strstr(TmpBuf1, ":")) != NULL) { 
				sqlfileok = 1;
			}
		}
		usesql = 1;
		fclose(fs);
	}
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td bgcolor=%s>\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s    <input type=checkbox name=sqlsupport value=-6 %s>", spacestring, checked1);
	fprintf(actout, "%s</td>\n", get_html_text("053"));
	fprintf(actout, "%s</tr>\n", spacestring);
	checked1[0] = '\0'; checked2[0] = 0;



	/* parse dir/sql file for SQL settings */
	fprintf(actout, "%s<tr>\n", spacestring);
	fprintf(actout, "%s  <td bgcolor=%s align=\"middle\">\n", spacestring, get_color_text("004"));
	fprintf(actout, "%s    <table cellpadding=\"0\" cellspacing=\"2\" border=0>\n", spacestring);
	fprintf(actout, "%s      <tr>\n", spacestring);
	fprintf(actout, "%s        <th colspan=2 align=\"middle\">%s&nbsp;</th>\n", spacestring, get_html_text("099"));
	fprintf(actout, "%s      <tr>\n", spacestring);

	/* get hostname */
	if(usesql == 1 && sqlfileok == 1) {
		strncpy(TmpBuf3, TmpBuf1, 1);       
		if((strstr(TmpBuf3, ":")) != NULL) { 
			strcpy(checked1, "localhost");
		} else {
			for(i=0,j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "localhost");
	}       
	fprintf(actout, "%s      <tr>\n", spacestring);
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("054"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=text name=sql1 value=\"%s\"></td>\n", spacestring, checked1);

	/* get port */
	if(usesql == 1 && sqlfileok == 1) {
		strncpy(TmpBuf3, &TmpBuf1[++i], 1);       
		if((strstr(TmpBuf3, ":")) != NULL) { 
			strcpy(checked1, "3306");
		} else {
			for(j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "3306");
	}       
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("055"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=text name=sql2 value=\"%s\"></td>\n", spacestring, checked1);
	fprintf(actout, "%s      </tr>\n", spacestring);

	/* get user */
	if(usesql == 1 && sqlfileok == 1) {
		strncpy(TmpBuf3, &TmpBuf1[++i], 1);       
		if((strstr(TmpBuf3, ":")) != NULL) { 
			strcpy(checked1, "");
		} else {
			for(j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "");
	}       
	fprintf(actout, "%s      <tr>\n", spacestring);
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("056"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=text name=sql3 value=\"%s\"></td>\n", spacestring, checked1);

	/* get password */
	if(usesql == 1 && sqlfileok == 1) {
		strncpy(TmpBuf3, &TmpBuf1[++i], 1);       
		if((strstr(TmpBuf3, ":")) != NULL) { 
			strcpy(checked1, "");
		} else {
			for(j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "");
	}       
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("057"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=text name=sql4 value=\"%s\"></td>\n", spacestring, checked1);
	fprintf(actout, "%s      </tr>\n", spacestring);

	/* get database name */
	if(usesql == 1 && sqlfileok == 1) {
		strncpy(TmpBuf3, &TmpBuf1[++i], 1);       
		if((strstr(TmpBuf3, ":")) != NULL) { 
			strcpy(checked1, "");
		} else {
			for(j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "");
	}       
	fprintf(actout, "%s      <tr>\n", spacestring);
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("058"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=text name=sql5 value=\"%s\"></td>\n", spacestring, checked1);

	/* get table name */
	if(usesql == 1 && sqlfileok == 1) {
		++i;
		if(strlen(TmpBuf1) == i) {
			strcpy(checked1, "ezmlm");
		} else {
			for(j=0;TmpBuf1[i]!=':'&&TmpBuf1[i]!='\0';++j,++i) checked1[j] = TmpBuf1[i];
			checked1[j] = '\0'; 
		}       
	} else {
		strcpy(checked1, "ezmlm");
	}       
	fprintf(actout, "%s        <td>%s\n",  spacestring, get_html_text("059"));
	fprintf(actout, "%s          <br>\n", spacestring);
	fprintf(actout, "%s          <input type=\"text\" name=\"sql6\" value=\"%s\"></td>\n", spacestring, checked1);
	fprintf(actout, "%s      </tr>\n", spacestring);
	fprintf(actout, "%s    </table>\n", spacestring);
	fprintf(actout, "%s</td></tr></table>\n", spacestring);

}


/* 
 * ezmlm-make -e leaves .qmail-listname-(accept||reject) links for some reason.
 * (causing file permission errors in "show mailing lists") Also, it doesn't 
 * delete dir/digest/ when turning off digests.  del_list_links() fixes these things
 *
 */
int del_list_links(char *linktype)
{
	int pid;
	char tmpstr[MAX_BUFF];
	DIR *mydir;
	struct dirent *mydirent;

	if ((mydir = opendir(".")) == NULL) {
		fprintf(actout,"<tr><td>%s %d</tr><td>\n", get_html_text("143"), 1);
		return 0;
	}
 
	if (strstr(linktype, "moderator") != 0) {
		sprintf(TmpBuf2, ".qmail-%s-accept-default", dotqmail_name);
		sprintf(TmpBuf3, ".qmail-%s-reject-default", dotqmail_name);
	} else if(strstr(linktype, "digest") != 0) {
		sprintf(TmpBuf2, ".qmail-%s-digest-return-default", dotqmail_name);
		sprintf(TmpBuf3, ".qmail-%s-digest-owner", dotqmail_name);
	}
	while( (mydirent=readdir(mydir)) != NULL ) {
		if ( strncmp(TmpBuf2, mydirent->d_name, strlen(TmpBuf2)) == 0 ) {
			if ( unlink(mydirent->d_name) != 0 ) {
				ack(get_html_text("185"), TmpBuf2);
			}
		}
		if ( strncmp(TmpBuf3, mydirent->d_name, strlen(TmpBuf3)) == 0 ) {
			if ( unlink(mydirent->d_name) != 0 ) {
				ack(get_html_text("185"), TmpBuf3);
			}
		}
	}
	closedir(mydir);

	/* delete the digest directory */
	if(strstr(linktype, "digest") != 0) {
		sprintf(tmpstr, "%s/%s/digest", RealDir, ActionUser);
		vdelfiles(tmpstr);
		chdir(RealDir);
	}
}

int get_ezmlmidx_line_arguments(char *line, char *program, char *argument)
{
	char *begin; 
	char *end;
	char *string;
	char *tmpbuf;
	int len;

	tmpbuf = malloc(400);

	if ((strstr(line, program)) != NULL) {
		begin=strchr(line, ' ');
		begin++;
		strncpy(tmpbuf, begin, 1);      
		if ((strstr(tmpbuf, "-")) != NULL) { 
			end=strchr(begin, ' ');
			len=end-begin;
			strncpy(tmpbuf, begin, len);    
			if ((strstr(tmpbuf, argument)) != NULL) { 
				return 1;
			}       
		}       
	}       
	return 0;
}

